/*****************************************************************
OpenCL parallel integrator based on Runge-Kutta schemes.

Copyright 2014 Marcos Rodriguez, Fernando Blesa and Roberto Barrio
http://cody.unizar.es/software/
Contact: <marcos@unizar.es>

This code is released under GPL license. See the web site above for citation instructions

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*****************************************************************/

#define MIN(a,b) ((a)<(b))? (a) : (b)
#define MAX(a,b) ((a)>(b))? (a) : (b)

#define DOPRI


#define DOUBLE		// #define DOUBLE	for 8 byte float
			// #define FLOAT	for 4 byte float

#define CPU		//#define GPU 		for GPU integration
			//#define CPU 		for CPU integration

#ifdef FLOAT
#define real_t float
#endif

#ifdef DOUBLE
#pragma OPENCL EXTENSION cl_khr_fp64 : enable
#define real_t double
#endif


#define N	(1024)			// NUMBER OF ORBITS (GLOBAL SIZE)
#define NVAR	(4)			// NUMBER OF VARIABLES
#define TF	(64.2652399541350)	// FINAL TIME

#define TOL	(1.0e-8)		// TOLERANCE
