/*****************************************************************
OpenCL parallel integrator based on Runge-Kutta schemes.

Copyright 2014 Marcos Rodriguez, Fernando Blesa and Roberto Barrio
http://cody.unizar.es/software/
Contact: <marcos@unizar.es>

This code is released under GPL license. See the web site above for citation instructions

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*****************************************************************/


// PARAMETERS
#include "parameters.h"

 
// HEADERS AND MACROS FOR VARIABLES
#include "openCL_var_names.h"

#include "fun.h"

#include "rk.h"

__kernel void test (__global real_t* g_x,
		    __global real_t* rand) {

	
	unsigned char i;
	real_t x[NVAR];
	
	x[0] = 0.0 + RAND(0);
	x[1] = 0.548463957942453 + RAND(1);
	x[2] = sqrt (2.0*(0.12) - x[1]*x[1] + 2.0/3.0*x[1]*x[1]*x[1]) + RAND(2);
	x[3] = 0.0 + RAND(3);
	
	
	rk (x);

	if (get_global_id(0) == 0) {
		X(0) = fabs (x[0]);
		X(0) = MAX (X(0), fabs (x[1] - 0.548463957942453));
		X(0) = MAX (X(0), fabs (x[2] - 0.221759421471907));
		X(0) = MAX (X(0), fabs (x[3]));
		X(1) = get_local_size(0);
	}

}

                                                                                              
        
                                 
